package vue;

// Simulation of the Game Pak
class GamePak {

    // Package fields
    byte[] ram;       // Cartridge SRAM
    byte[] rom;       // Cartridge ROM
    int    wcr_exp1w; // Expansion one-wait mode
    int    wcr_rom1w; // ROM one-wait mode

    // Private fields
    private JavaVue vue; // Emulation state



    ///////////////////////////////////////////////////////////////////////////
    //                             Constructors                              //
    ///////////////////////////////////////////////////////////////////////////

    // Default constructor
    GamePak(JavaVue vue) {
        this.vue = vue;
    }



    ///////////////////////////////////////////////////////////////////////////
    //                            Package Methods                            //
    ///////////////////////////////////////////////////////////////////////////

    // System reset
    void reset() {
        wcr_exp1w = 0;
        wcr_rom1w = 0;
    }

}
